local assets =
{
    Asset("ANIM", "anim/valentinescard.zip"),
	Asset("ATLAS", "images/inventoryimages/valentinescard.xml"),
    Asset("IMAGE", "images/inventoryimages/valentinescard.tex"),
	Asset("ANIM", "anim/vhearts.zip"),
}

local prefabs =
{
    "eheartfx",
}

local VALENWORDS = { --Credited card quotes from the lovely denizens of the RPP discord 
	"\"I love you!\"",
	"\"I love you! -W\"",
	"\"There's no one I'd rather survive with than you!\"", --WeeTrell
	"\"You're sweeter than taffy, Valentine.\"", --Jelly
	"\"Flowers have nothing on your beauty, Valentine.\"", --WeeTrell
	"\"Even in the summer you're pretty cool!\"", --Charlie
	"\"We may be starving, but at least we're together, Valentine.\"", --Charlie
	"\"Roses are red, ice hounds are blue; I'm trapped in the Constant, but at least it's with you\"", --Karma
	"\"You drive me wild, Valentine!\"", --Sprockets
	"\"My love for you shines brighter than any torch.\"", --WeeTrell
	"\"Say, pal... you look GREAT!\"", --Karma
	"\"Are you an evil flower? Because I sure am crazy for you!\"", --WeeTrell
	"\"I would walk through the shadows for you.\"", --WeeTrell
	"\"Summer must have come early, because you're smokin'.\"", --Karma
	"\"Can we cuddle? It's for science...\"", --Charlie
	"\"I would give you my last meatball, Valentine.\"", --WeeTrell
	"\"Who needs a garland when you have love to keep you sane?\"", --WeeTrell
	"\"Is that a giant I hear, or is it just my heart beating for you?\"", --WeeTrell
	"\"I feel like a Tallbird, because I've got my eye on you.\"", --Karma
	"\"Are you the Moose/Goose, because you confuse and terrify me.\" ...That's not very romantic.", --Karma
	"\"Roses are thorny, mandrakes are loud, the way you survive makes my heart proud\"", --WeeTrell
	"\"My love for you is stronger than the Dragonfly, Valentine!\"", --Crow
	"\"You give me more life than any amulet.\"", --Karma
	"\"Your smile is bright enough to keep the night hands at bay\"", --WeeTrell
	"\"Dragon pie, honey nuggets, you know that I love you?\"", --Charlie
	"\"Your love is magical enough to replace a Shadow Manipulator.\"", --Jelly
	"\"Valentine, thoughts of you are keeping me up at night. (That, and the horrible whispers.)\"", --Karma
	"\"Is that feeling in my stomach hunger, or just butterflies for you?\"", --WeeTrell
	"\"Are you the night monster? Because you take my breath away!\"", --WeeTrell
	"\"This tell-tale heart beats only for you, Valentine\"", --WeeTrell
	"\"Are you a Glow Berry? Because you light up my life!\"", --WeeTrell
	"\"I better stay by the lightning rod, because you are electrifying!\"", --WeeTrell
	"\"Your beauty is brighter than the fullest moon!\"", --WeeTrell
	"\"You make my heart beat louder than a mandrake, Valentine!\"", --WeeTrell
	"\"You must be a Belt of Hunger, because I feel empty without you!\"", --Noxu
	"\"Are you the Antlion? Because you rock my world!\"", --Noxu
	"\"Are you a Shadow Manipulator? Because when I'm near you it's like magic!\"", --Noxu
	"\"Mushrooms are red, except when they're blue; and those that are green make me crazy for you!\"", --Karma
	"\"Will Ewelet me hold your hand, Valentine?\"", --Karma
	"\"YOU HAVE YOUR USES, HUMAN\"", --Dero
	"\"YOU ARE OK FOR A HUMAN\"", --Cameo
	"\"Are you a ghost, because I'd give you my heart.\"", --Skits
	"\"You hold the Ancient Key to my heart, Valentine!\"", --butlerkitties
	"\"Are you Deerclops? Because you look smashing.\"", --Skits
	"\"You're more precious than Thulecite, Valentine!\"", --Skits
	"\"To: W. From: W.\" Well, that narrows it down.", --Karma
	"There's a lot of little hearts all over the paper!", --Dero
	"\"Are you a batilisk? Because I'm going batty over you!\"", --Karma
	"\"The shadows stole us out of the real world, but you've stolen my heart, Valentine!\"", --Karma
	"\"Are you flint? Because I can't get enough of you!\"", --Username
	"\"Are you the Glommer? Because I find myself feeling happy just being around you!\"", --Pearasect
	"\"WHY ARE WE EXCHANGING PAPER\"" --Dero
}

local function onsave(inst, data)
    data.setepitaph = inst.setepitaph
end

local function onload(inst, data, newents)
    if data then
        if data.setepitaph then
            --this handles custom epitaphs set in the tile editor
            inst.components.inspectable:SetDescription("'"..data.setepitaph.."'")
            inst.setepitaph = data.setepitaph
        end
    end
end

local function OnDropped(inst)
    if inst.hearts == nil then
	local x,y,z = inst.Transform:GetWorldPosition()
        inst.hearts = inst:SpawnChild("eheartfx")
		inst.hearts.Transform:SetPosition(x,1,z)
    end
end

local function OnPickup(inst)
    if inst.hearts ~= nil then
        inst.hearts:Remove()
        inst.hearts = nil
    end
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
    MakeInventoryPhysics(inst)
	inst.entity:AddLight()
	inst.entity:AddMiniMapEntity()

	inst.AnimState:SetBank("valentinescard")
	inst.AnimState:SetBuild("valentinescard")
	inst.AnimState:PlayAnimation("idle")

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.Light:Enable(false)
    inst.Light:SetRadius(.2)
    inst.Light:SetFalloff(2)
    inst.Light:SetIntensity(.2)
    inst.Light:SetColour(235/255,62/255,12/255)

    inst:AddComponent("inspectable")
    inst.components.inspectable:SetDescription(VALENWORDS[math.random(#VALENWORDS)])
	
	inst.MiniMapEntity:SetIcon("valentinescard.tex")

    inst:AddComponent("inventoryitem")   
    inst.components.inventoryitem.atlasname = "images/inventoryimages/valentinescard.xml"
	
	inst.flies = inst:SpawnChild("eheartfx")

    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.SMALL_FUEL

    MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    MakeSmallPropagator(inst)
	
	inst.OnLoad = onload
    inst.OnSave = onsave

    MakeHauntableLaunch(inst)

    return inst
end

local function heartfxfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddPhysics()
    inst.entity:AddNetwork()

    inst:AddTag("NOBLOCK")
    inst:AddTag("NOCLICK")
    inst:AddTag("FX")

    inst.AnimState:SetBank("fireflies")
    inst.AnimState:SetBuild("vhearts")
    inst.AnimState:PlayAnimation("swarm_loop", true)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
    inst.persists = false
    inst.AnimState:SetMultColour( 200/255, 50/255, 50/255, 1 )

    return inst
end

STRINGS.VALENTINESCARD = "Valentines Note"
STRINGS.NAMES.VALENTINESCARD = "Valentines Card"
STRINGS.RECIPE_DESC.VALENTINESCARD = "Share a sweet note."

return Prefab("valentinescard", fn, assets),
	Prefab("eheartfx", heartfxfn, assets)